                --------------------
                -- Mouse Routines --
                --------------------

-- You need DOS mouse support for these routines.

-- Mouse Event Numbers:
global constant MOVE        = 1,  -- track every movement of the mouse
                LEFT_DOWN   = 2,  -- the rest are button pressing/releasing
                LEFT_UP     = 4,
                RIGHT_DOWN  = 8,
                RIGHT_UP    = 16,
                MIDDLE_DOWN = 32,
                MIDDLE_UP   = 64

sequence  m_pos
integer   m_visible, m_buts, m_event
m_visible = 1   -- not visible
m_event   = #3F -- all active
with trace
--trace(1)
global function get_mouse()
-- report mouse events,
-- returns -1 if no mouse event,
-- otherwise returns {event#, x-coord, y-coord}
    object   me

    me = text_mouse()
    if sequence(me) then 
       if and_bits(me[1],m_event)=0 then
          me = -1
       end if
    end if
    return me
end function

global procedure mouse_events(integer events)
-- select the mouse events to be reported by get_mouse()
-- e.g. mouse_events(LEFT_UP + LEFT_DOWN + RIGHT_DOWN)
--  machine_proc(M_MOUSE_EVENTS, events)
    m_event = events
end procedure

